<!--
  ~ iparapheur Web
  ~ Copyright (C) 2019-2025 Libriciel SCOP
  ~
  ~ This program is free software: you can redistribute it and/or modify
  ~ it under the terms of the GNU Affero General Public License as published by
  ~ the Free Software Foundation, either version 3 of the License, or
  ~ (at your option) any later version.
  ~
  ~ This program is distributed in the hope that it will be useful,
  ~ but WITHOUT ANY WARRANTY; without even the implied warranty of
  ~ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  ~ GNU Affero General Public License for more details.
  ~
  ~ You should have received a copy of the GNU Affero General Public License
  ~ along with this program. If not, see <http://www.gnu.org/licenses/>.
  -->

<form class="ls-form">

  <div class="form-group">
    <label
      for="metadataList"
      [innerText]="messages.LINK_METADATA_">
    </label>

    <div class="d-flex flex-row">
      <ng-select
        id="metadataList"
        class="flex-grow-1"
        [items]="filteredMetadataList"
        [(ngModel)]="selectedMetadata"
        [notFoundText]="commonMessages.NOT_FOUND"
        [clearAllText]="commonMessages.CLEAR"
        [multiple]="false"
        [clearable]="true"
        [searchFn]="searchMetadata"
        [ngModelOptions]="{standalone: true}">

        <ng-template let-item="item" ng-option-tmp>
          {{ item.name | namePipe }}
        </ng-template>

        <ng-template let-item="item" ng-label-tmp>
          <span class="ng-value-label" [innerText]="item.name"></span>
        </ng-template>

      </ng-select>

      <button
        type="button"
        class="btn btn-sm btn-outline-primary ms-2"
        [disabled]="!selectedMetadata"
        (click)="onAddMetadataButtonClicked()">
        <fa-icon [icon]="linkIcon"></fa-icon>
        {{ commonMessages.LINK }}
      </button>
    </div>
  </div>

  <div class="form-group">

    <label
      id="linkedMetadataTitle"
      [innerText]="messages.LINKED_METADATA_">
    </label>

    <table
      aria-labelledby="linkedMetadataTitle"
      class="mt-2 bg-white table table-striped table-borderless border">
      <thead class="border">
        <tr>
          <th scope="col" class="th-sm" [innerText]="commonMessages.NAME"></th>
          <th scope="col" class="th-sm col-id-fixed-size" [innerText]="messages.DEFAULT_VALUE"></th>
          <th scope="col" class="th-sm col-buttons-fixed-size" [innerText]="messages.MANDATORY"></th>
          <th scope="col" class="th-sm col-buttons-fixed-size" [innerText]="messages.EDITABLE"></th>
          <th scope="col" class="th-sm col-buttons-fixed-size" [innerText]="commonMessages.UNLINK"></th>
        </tr>
      </thead>
      <tbody *ngIf="subtype.subtypeMetadataList">
        <tr *ngFor="let subtypeMetadata of subtype.subtypeMetadataList">
          <td [innerText]="subtypeMetadata.metadata.name | namePipe"></td>
          <td>
            <app-metadata-input
              [type]="subtypeMetadata.metadata.type"
              [restrictedValues]="subtypeMetadata.metadata.restrictedValues"
              [editable]="true"
              [mandatory]="false"
              [(value)]="subtypeMetadata.defaultValue">
            </app-metadata-input>
          </td>
          <td>
            <div class="custom-control custom-checkbox">
              <input
                class="custom-control-input"
                type="checkbox"
                [(ngModel)]="subtypeMetadata.mandatory"
                [ngModelOptions]="{standalone: true}"
                [id]="'checkbox_mandatory_' + subtypeMetadata.metadata.id">
              <label
                class="custom-control-label"
                [htmlFor]="'checkbox_mandatory_' + subtypeMetadata.metadata.id">
              </label>
            </div>
          </td>
          <td>
            <div class="custom-control custom-checkbox">
              <input
                class="custom-control-input"
                type="checkbox"
                [(ngModel)]="subtypeMetadata.editable"
                [ngModelOptions]="{standalone: true}"
                [id]="'checkbox_editable_' + subtypeMetadata.metadata.id">
              <label
                class="custom-control-label"
                [htmlFor]="'checkbox_editable_' + subtypeMetadata.metadata.id">
              </label>
            </div>
          </td>
          <td>
            <button
              type="button"
              class="btn btn-sm btn-outline-danger me-2"
              (click)="onUnlinkButtonClicked(subtypeMetadata)">
              <fa-icon [icon]="unlinkIcon"></fa-icon>
            </button>
          </td>
        </tr>
      </tbody>
      <tbody
        app-list-loader
        [emptyMessage]="commonMessages.EMPTY_METADATA_LIST"
        [data]="subtype.subtypeMetadataList"
        [loading]="loading"
        [colspan]="5">
      </tbody>
    </table>

    <ngb-pagination
      class="d-flex justify-content-end"
      size="sm"
      [collectionSize]="total"
      [pageSize]="getPageSize(pageSizeIndex)"
      [(page)]="page"
      [maxSize]="5"
      [rotate]="true"
      [boundaryLinks]="false"
      [directionLinks]="false">
    </ngb-pagination>
  </div>

</form>
